var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// ../../node_modules/@minecraft/math/lib/general/clamp.js
var require_clamp = __commonJS({
  "../../node_modules/@minecraft/math/lib/general/clamp.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.clampNumber = void 0;
    function clampNumber(val, min, max) {
      return Math.min(Math.max(val, min), max);
    }
    exports.clampNumber = clampNumber;
  }
});

// ../../node_modules/@minecraft/math/lib/vector3/coreHelpers.js
var require_coreHelpers = __commonJS({
  "../../node_modules/@minecraft/math/lib/vector3/coreHelpers.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.VECTOR3_SOUTH = exports.VECTOR3_NORTH = exports.VECTOR3_EAST = exports.VECTOR3_WEST = exports.VECTOR3_ZERO = exports.VECTOR3_ONE = exports.VECTOR3_BACK = exports.VECTOR3_FORWARD = exports.VECTOR3_RIGHT = exports.VECTOR3_LEFT = exports.VECTOR3_DOWN = exports.VECTOR3_UP = exports.Vector2Utils = exports.Vector3Utils = void 0;
    var clamp_1 = require_clamp();
    var Vector3Utils = class _Vector3Utils {
      /**
       * equals
       *
       * Check the equality of two vectors
       */
      static equals(v1, v2) {
        return v1.x === v2.x && v1.y === v2.y && v1.z === v2.z;
      }
      /**
       * add
       *
       * Add two vectors to produce a new vector
       */
      static add(v1, v2) {
        return { x: v1.x + v2.x, y: v1.y + v2.y, z: v1.z + v2.z };
      }
      /**
       * subtract
       *
       * Subtract two vectors to produce a new vector (v1-v2)
       */
      static subtract(v1, v2) {
        return { x: v1.x - v2.x, y: v1.y - v2.y, z: v1.z - v2.z };
      }
      /** scale
       *
       * Multiple all entries in a vector by a single scalar value producing a new vector
       */
      static scale(v1, scale) {
        return { x: v1.x * scale, y: v1.y * scale, z: v1.z * scale };
      }
      /**
       * dot
       *
       * Calculate the dot product of two vectors
       */
      static dot(a, b) {
        return a.x * b.x + a.y * b.y + a.z * b.z;
      }
      /**
       * cross
       *
       * Calculate the cross product of two vectors. Returns a new vector.
       */
      static cross(a, b) {
        return {
          x: a.y * b.z - a.z * b.y,
          y: a.z * b.x - a.x * b.z,
          z: a.x * b.y - a.y * b.x
        };
      }
      /**
       * magnitude
       *
       * The magnitude of a vector
       */
      static magnitude(v) {
        return Math.sqrt(v.x ** 2 + v.y ** 2 + v.z ** 2);
      }
      /**
       * distance
       *
       * Calculate the distance between two vectors
       */
      static distance(a, b) {
        return _Vector3Utils.magnitude(_Vector3Utils.subtract(a, b));
      }
      /**
       * normalize
       *
       * Takes a vector 3 and normalizes it to a unit vector
       */
      static normalize(v) {
        const mag = _Vector3Utils.magnitude(v);
        return { x: v.x / mag, y: v.y / mag, z: v.z / mag };
      }
      /**
       * floor
       *
       * Floor the components of a vector to produce a new vector
       */
      static floor(v) {
        return { x: Math.floor(v.x), y: Math.floor(v.y), z: Math.floor(v.z) };
      }
      /**
       * toString
       *
       * Create a string representation of a vector3
       */
      static toString(v, options) {
        const decimals = options?.decimals ?? 2;
        const str = [v.x.toFixed(decimals), v.y.toFixed(decimals), v.z.toFixed(decimals)];
        return str.join(options?.delimiter ?? ", ");
      }
      /**
       * clamp
       *
       * Clamps the components of a vector to limits to produce a new vector
       */
      static clamp(v, limits) {
        return {
          x: (0, clamp_1.clampNumber)(v.x, limits?.min?.x ?? Number.MIN_SAFE_INTEGER, limits?.max?.x ?? Number.MAX_SAFE_INTEGER),
          y: (0, clamp_1.clampNumber)(v.y, limits?.min?.y ?? Number.MIN_SAFE_INTEGER, limits?.max?.y ?? Number.MAX_SAFE_INTEGER),
          z: (0, clamp_1.clampNumber)(v.z, limits?.min?.z ?? Number.MIN_SAFE_INTEGER, limits?.max?.z ?? Number.MAX_SAFE_INTEGER)
        };
      }
      /**
       * lerp
       *
       * Constructs a new vector using linear interpolation on each component from two vectors.
       */
      static lerp(a, b, t) {
        return {
          x: a.x + (b.x - a.x) * t,
          y: a.y + (b.y - a.y) * t,
          z: a.z + (b.z - a.z) * t
        };
      }
      /**
       * slerp
       *
       * Constructs a new vector using spherical linear interpolation on each component from two vectors.
       */
      static slerp(a, b, t) {
        const theta = Math.acos(_Vector3Utils.dot(a, b));
        const sinTheta = Math.sin(theta);
        const ta = Math.sin((1 - t) * theta) / sinTheta;
        const tb = Math.sin(t * theta) / sinTheta;
        return _Vector3Utils.add(_Vector3Utils.scale(a, ta), _Vector3Utils.scale(b, tb));
      }
    };
    exports.Vector3Utils = Vector3Utils;
    var Vector2Utils = class {
      /**
       * toString
       *
       * Create a string representation of a vector2
       */
      static toString(v, options) {
        const decimals = options?.decimals ?? 2;
        const str = [v.x.toFixed(decimals), v.y.toFixed(decimals)];
        return str.join(options?.delimiter ?? ", ");
      }
    };
    exports.Vector2Utils = Vector2Utils;
    exports.VECTOR3_UP = { x: 0, y: 1, z: 0 };
    exports.VECTOR3_DOWN = { x: 0, y: -1, z: 0 };
    exports.VECTOR3_LEFT = { x: -1, y: 0, z: 0 };
    exports.VECTOR3_RIGHT = { x: 1, y: 0, z: 0 };
    exports.VECTOR3_FORWARD = { x: 0, y: 0, z: 1 };
    exports.VECTOR3_BACK = { x: 0, y: 0, z: -1 };
    exports.VECTOR3_ONE = { x: 1, y: 1, z: 1 };
    exports.VECTOR3_ZERO = { x: 0, y: 0, z: 0 };
    exports.VECTOR3_WEST = { x: -1, y: 0, z: 0 };
    exports.VECTOR3_EAST = { x: 1, y: 0, z: 0 };
    exports.VECTOR3_NORTH = { x: 0, y: 0, z: 1 };
    exports.VECTOR3_SOUTH = { x: 0, y: 0, z: -1 };
  }
});

// ../../node_modules/@minecraft/math/lib/vector3/vectorWrapper.js
var require_vectorWrapper = __commonJS({
  "../../node_modules/@minecraft/math/lib/vector3/vectorWrapper.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Vector2Builder = exports.Vector3Builder = void 0;
    var coreHelpers_1 = require_coreHelpers();
    var Vector3Builder = class {
      constructor(first, y, z) {
        if (typeof first === "object") {
          this.x = first.x;
          this.y = first.y;
          this.z = first.z;
        } else {
          this.x = first;
          this.y = y ?? 0;
          this.z = z ?? 0;
        }
      }
      /**
       * Assigns the values of the passed in vector to this vector. Returns itself.
       */
      assign(vec) {
        this.x = vec.x;
        this.y = vec.y;
        this.z = vec.z;
        return this;
      }
      /**
       * equals
       *
       * Check the equality of two vectors
       */
      equals(v) {
        return coreHelpers_1.Vector3Utils.equals(this, v);
      }
      /**
       * add
       *
       * Adds the vector v to this, returning itself.
       */
      add(v) {
        return this.assign(coreHelpers_1.Vector3Utils.add(this, v));
      }
      /**
       * subtract
       *
       * Subtracts the vector v from this, returning itself.
       */
      subtract(v) {
        return this.assign(coreHelpers_1.Vector3Utils.subtract(this, v));
      }
      /** scale
       *
       * Scales this by the passed in value, returning itself.
       */
      scale(val) {
        return this.assign(coreHelpers_1.Vector3Utils.scale(this, val));
      }
      /**
       * dot
       *
       * Computes the dot product of this and the passed in vector.
       */
      dot(vec) {
        return coreHelpers_1.Vector3Utils.dot(this, vec);
      }
      /**
       * cross
       *
       * Computes the cross product of this and the passed in vector, returning itself.
       */
      cross(vec) {
        return this.assign(coreHelpers_1.Vector3Utils.cross(this, vec));
      }
      /**
       * magnitude
       *
       * The magnitude of the vector
       */
      magnitude() {
        return coreHelpers_1.Vector3Utils.magnitude(this);
      }
      /**
       * distance
       *
       * Calculate the distance between two vectors
       */
      distance(vec) {
        return coreHelpers_1.Vector3Utils.distance(this, vec);
      }
      /**
       * normalize
       *
       * Normalizes this vector, returning itself.
       */
      normalize() {
        return this.assign(coreHelpers_1.Vector3Utils.normalize(this));
      }
      /**
       * floor
       *
       * Floor the components of a vector to produce a new vector
       */
      floor() {
        return this.assign(coreHelpers_1.Vector3Utils.floor(this));
      }
      /**
       * toString
       *
       * Create a string representation of a vector
       */
      toString(options) {
        return coreHelpers_1.Vector3Utils.toString(this, options);
      }
      /**
       * clamp
       *
       * Clamps the components of a vector to limits to produce a new vector
       */
      clamp(limits) {
        return this.assign(coreHelpers_1.Vector3Utils.clamp(this, limits));
      }
      /**
       * lerp
       *
       * Constructs a new vector using linear interpolation on each component from two vectors.
       */
      lerp(vec, t) {
        return this.assign(coreHelpers_1.Vector3Utils.lerp(this, vec, t));
      }
      /**
       * slerp
       *
       * Constructs a new vector using spherical linear interpolation on each component from two vectors.
       */
      slerp(vec, t) {
        return this.assign(coreHelpers_1.Vector3Utils.slerp(this, vec, t));
      }
    };
    exports.Vector3Builder = Vector3Builder;
    var Vector2Builder = class {
      constructor(first, y) {
        if (typeof first === "object") {
          this.x = first.x;
          this.y = first.y;
        } else {
          this.x = first;
          this.y = y ?? 0;
        }
      }
      toString(options) {
        return coreHelpers_1.Vector2Utils.toString(this, options);
      }
    };
    exports.Vector2Builder = Vector2Builder;
  }
});

// ../../node_modules/@minecraft/math/lib/vector3/index.js
var require_vector3 = __commonJS({
  "../../node_modules/@minecraft/math/lib/vector3/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_coreHelpers(), exports);
    __exportStar(require_vectorWrapper(), exports);
  }
});

// ../../node_modules/@minecraft/math/lib/general/index.js
var require_general = __commonJS({
  "../../node_modules/@minecraft/math/lib/general/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_clamp(), exports);
  }
});

// ../../node_modules/@minecraft/math/lib/index.js
var require_lib = __commonJS({
  "../../node_modules/@minecraft/math/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() {
          return m[k];
        } };
      }
      Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_vector3(), exports);
    __exportStar(require_general(), exports);
  }
});

// BP/scripts/main.ts
import { EnchantmentType, EntityComponentTypes, EquipmentSlot, ItemStack, system, world } from "@minecraft/server";

// BP/scripts/config.ts
var disallowed_items = [
  "mcpe:improvised_bag",
  "mcpe:school_blue_backpack",
  "mcpe:school_red_backpack",
  "mcpe:school_green_backpack",
  "mcpe:taloon_yellow_backpack",
  "mcpe:taloon_red_backpack",
  "mcpe:taloon_blue_backpack",
  "mcpe:taloon_green_backpack",
  "minecraft:skull",
  "minecraft:bed",
  "minecraft:chemistry_table",
  "minecraft:empty_map",
  "minecraft:filled_map",
  "minecraft:tropical_fish_bucket",
  "minecraft:axolotl_bucket",
  "minecraft:salmon_bucket",
  "minecraft:banner",
  "minecraft:potion",
  "minecraft:splash_potion",
  "minecraft:lingering_potion",
  "minecraft:goat_horn",
  "minecraft:arrow",
  "minecraft:firework_star",
  "minecraft:firework_rocket",
  "minecraft:leather_horse_armor",
  "minecraft:lodestone_compass",
  "minecraft:shield",
  "minecraft:chainmail_helmet",
  "minecraft:chainmail_chestplate",
  "minecraft:chainmail_leggings",
  "minecraft:chainmail_boots",
  "minecraft:diamond_helmet",
  "minecraft:diamond_chestplate",
  "minecraft:diamond_leggings",
  "minecraft:diamond_boots",
  "minecraft:golden_helmet",
  "minecraft:golden_chestplate",
  "minecraft:golden_leggings",
  "minecraft:golden_boots",
  "minecraft:iron_helmet",
  "minecraft:iron_chestplate",
  "minecraft:iron_leggings",
  "minecraft:iron_boots",
  "minecraft:leather_helmet",
  "minecraft:leather_chestplate",
  "minecraft:leather_leggings",
  "minecraft:leather_boots",
  "minecraft:netherite_helmet",
  "minecraft:netherite_chestplate",
  "minecraft:netherite_leggings",
  "minecraft:netherite_boots",
  "minecraft:turtle_helmet",
  "hatchi:backpack",
  "minecraft:black_shulker_box",
  "minecraft:blue_shulker_box",
  "minecraft:brown_shulker_box",
  "minecraft:cyan_shulker_box",
  "minecraft:gray_shulker_box",
  "minecraft:green_shulker_box",
  "minecraft:light_blue_shulker_box",
  "minecraft:light_gray_shulker_box",
  "minecraft:lime_shulker_box",
  "minecraft:magenta_shulker_box",
  "minecraft:orange_shulker_box",
  "minecraft:pink_shulker_box",
  "minecraft:purple_shulker_box",
  "minecraft:red_shulker_box",
  "minecraft:undyed_shulker_box",
  "minecraft:white_shulker_box",
  "minecraft:yellow_shulker_box"
];

const Backpack = {
  // school
  "school_blue_backpack": {
    container: "mcpe:school_backpack_container",
    name: "Blue School Backpack"
  },
  "school_green_backpack": {
    container: "mcpe:school_backpack_container",
    name: "Green School Backpack"
  },
  "school_red_backpack": {
    container: "mcpe:school_backpack_container",
    name: "Red School Backpack"
  },
  // taloon
  "taloon_yellow_backpack": {
    container: "mcpe:taloon_backpack_container",
    name: "Yellow Taloon Backpack"
  },
  "taloon_blue_backpack": {
    container: "mcpe:taloon_backpack_container",
    name: "Blue Taloon Backpack"
  },
  "taloon_green_backpack": {
    container: "mcpe:taloon_backpack_container",
    name: "Green Taloon Backpack"
  },
  "taloon_red_backpack": {
    container: "mcpe:taloon_backpack_container",
    name: "Red Taloon Backpack"
  }
};

// BP/scripts/main.ts
var import_math = __toESM(require_lib(), 1);
var containers = {};
var last_id = world.getDynamicProperty("mcpe:last_backpack_id") ?? 0;

function tick() {
  for (const container of Object.values(containers)) {
    container.in_use = false;
  }
  for (const player of world.getAllPlayers()) {
    let inventory = player.getComponent(EntityComponentTypes.Inventory)?.container;
    if (inventory == void 0) {
      console.error("inventory container undefined on player");
      continue;
    }
    const held_item = inventory.getItem(player.selectedSlotIndex);
    if (held_item == null || !held_item.typeId.startsWith("mcpe:")) {
      continue;
    }
    
    const backpackType = Object.keys(Backpack).find(type => held_item.typeId.includes(type));
    if (!backpackType) {
      continue;
    }
    
    let backpack_id = held_item.getDynamicProperty("hatchi:backpack_id");
    if (backpack_id == void 0) {
      last_id += 1;
      backpack_id = last_id;
      world.setDynamicProperty("mcpe:last_backpack_id", backpack_id);
      held_item.setDynamicProperty("hatchi:backpack_id", backpack_id);
      inventory.setItem(player.selectedSlotIndex, held_item);
    }
    held_item.setLore([
      "Backpack " + String(backpack_id),
      "Press the Screen/Right Click to Open"
    ]);
    let backpack_entity;
    if (containers[backpack_id] == void 0) {
    	const containerType = Backpack[backpackType].container;
        const backpackName = Backpack[backpackType].name;
        if (!containerType) {
        console.error("Unknown backpack type.");
        continue;
      }
      backpack_entity = player.dimension.spawnEntity(
        containerType,
        import_math.Vector3Utils.add(player.location, import_math.Vector3Utils.scale(import_math.VECTOR3_UP, 3))
      );
      backpack_entity.nameTag = backpackName;
      containers[backpack_id] = {
        entity: backpack_entity,
        in_use: false,
        last_used_by_player: player
      };
      const backpack_data_str = held_item.getDynamicProperty("mcpe:backpack_data");
      if (typeof backpack_data_str === "string") {
        const backpack_data = JSON.parse(backpack_data_str);
        const backpack_inventory2 = backpack_entity.getComponent(EntityComponentTypes.Inventory)?.container;
        if (backpack_inventory2 == void 0) {
          console.error("inventory container undefined on backpack");
          return;
        }
        fillBundleInventory(backpack_data, backpack_inventory2);
      }
    } else {
      const possible_entity = containers[backpack_id].entity;
      if (possible_entity != void 0) {
        backpack_entity = possible_entity;
      } else {
        console.error("Unable to find backpack container entity.");
        continue;
      }
    }
    containers[backpack_id].in_use = true;
    containers[backpack_id].last_used_by_player = player;
    backpack_entity.teleport(player.getHeadLocation());
    const backpack_inventory = backpack_entity.getComponent(EntityComponentTypes.Inventory)?.container;
    if (backpack_inventory == void 0) {
      console.error("inventory container undefined on backpack");
      continue;
    }
    const data = [];
    for (let slot = 0; slot < backpack_inventory.size; slot++) {
      const itemstack = backpack_inventory.getItem(slot);
      if (itemstack == void 0) {
        data.push(null);
        continue;
      }
      const components = itemstack.getComponents();
      const item = {
        typeId: itemstack.typeId,
        components: [],
        nameTag: itemstack.nameTag,
        amount: itemstack.amount ?? 1
      };
      for (const component of components) {
        const typeId = component.typeId;
        if (typeId == "minecraft:enchantable") {
          const component2 = {
            typeId: "minecraft:enchantable",
            enchantments: itemstack.getComponent("enchantable")?.getEnchantments().map(
              (enchanment) => {
                const type = enchanment.type.id;
                return {
                  type,
                  level: enchanment.level
                };
              }
            ) ?? []
          };
          item.components.push(component2);
        } else if (typeId == "minecraft:durability") {
          const component2 = {
            typeId: "minecraft:durability",
            damage: itemstack.getComponent("durability")?.damage
          };
          item.components.push(component2);
        } else if (typeId == "minecraft:cooldown") {
        	} else if (typeId == "minecraft:food") {
        	} else if (typeId == "minecraft:compostable") {
        } else {
          console.error("unhandled item component: " + typeId);
        }
      }
      const item_disallowed = disallowed_items.includes(itemstack.typeId) || itemstack.getDynamicPropertyIds().length > 0;
      if (item_disallowed) {
        player.sendMessage(
          [
            { text: "\xA7c[!] " },
            { translate: "game.message.unsupport_warning" }
          ]
        );
        player.playSound("note.bassattack");
        backpack_inventory.transferItem(slot, inventory);
        updateInventory(player);
      }
      data.push(item);
    }
    const inventory_data = JSON.stringify(data);
    held_item.setDynamicProperty("mcpe:backpack_data", inventory_data);
    inventory.setItem(player.selectedSlotIndex, held_item);
  }
  for (const container of Object.values(containers)) {
    if (!container.in_use) {
      const entity = container.entity;
      if (entity == void 0)
        continue;
      const new_pos = entity.location;
      new_pos.y = 400;
      entity.teleport(
        new_pos
      );
      if (container.last_used_by_player == null)
        continue;
      const backpack_inventory = entity.getComponent("inventory")?.container;
      if (backpack_inventory == void 0) {
        console.error("inventory container undefined on backpack");
        continue;
      }
      const player = container.last_used_by_player;
      for (let slot = 0; slot < backpack_inventory.size; slot++) {
        const itemstack = backpack_inventory.getItem(slot);
        if (itemstack == void 0) {
          continue;
        }
        if (disallowed_items.includes(itemstack.typeId)) {
          player.sendMessage(
            [
              { text: "\xA7c[!] " },
              { translate: "game.message.unsupport_warning" }
            ]
          );
          player.playSound("note.bassattack");
          let inventory = player.getComponent("inventory")?.container;
          if (inventory == void 0) {
            throw Error("inventory container undefined on player");
          }
          backpack_inventory.transferItem(slot, inventory);
          updateInventory(player);
        }
      }
    }
  }
}
function init() {
  for (const backpackData of Object.values(Backpack)) {
    const containerType = backpackData.container;
    const backpacks = world.getDimension("overworld").getEntities({
      type: containerType
    });
    for (const backpack of backpacks) {
      backpack.remove();
    }
  }
}
function updateInventory(player) {
  let inventory = player.getComponent("inventory")?.container;
  if (inventory == void 0) {
    throw Error("inventory container undefined on player");
  }
  inventory.addItem(
    new ItemStack(
      "mcpe:false_air",
      1
    )
  );
  player.runCommand("clear @s mcpe:false_air");
}
function fillBundleInventory(backpack_data, inventory) {
  for (const [slot, item] of backpack_data.entries()) {
    if (item == null)
      continue;
    const itemstack = new ItemStack(
      item.typeId
    );
    itemstack.amount = item.amount;
    itemstack.nameTag = item.nameTag;
    for (const component of item.components) {
      const typeId = component.typeId;
      if (typeId == "minecraft:durability") {
        const representation = component;
        let durability = itemstack.getComponent("minecraft:durability");
        if (durability == void 0)
          continue;
        if (representation.damage == void 0)
          continue;
        durability.damage = representation.damage;
      } else if (typeId == "minecraft:enchantable") {
        const representation = component;
        let enchantments = itemstack.getComponent("minecraft:enchantable");
        if (enchantments == void 0)
          continue;
        for (const enchanment of representation.enchantments) {
          enchantments.addEnchantment(
            {
              level: enchanment.level,
              type: new EnchantmentType(enchanment.type)
            }
          );
        }
      } else {
        console.error("Unexpected component representation: " + typeId);
      }
    }
    inventory.setItem(
      slot,
      itemstack
    );
  }
}
world.beforeEvents.itemUse.subscribe((event) => {
  if (event.itemStack.typeId.startsWith("mcpe:") && Object.keys(Backpack).some(type => event.itemStack.typeId.includes(type))) {
    system.run(
      () => {
        const item = event.source.getComponent("equippable")?.getEquipment(
          EquipmentSlot.Chest
        )?.typeId;
        if (item == void 0) {
          event.source.getComponent("equippable")?.setEquipment(
            EquipmentSlot.Chest,
            new ItemStack("minecraft:air")
          );
        }
      }
    );
    return event.cancel = true;
  }
});
init();
system.runInterval(tick, 1);
